/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G14 V2.05.04.02 [20 Nov 2019]
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
/* Start user code for include. Do not edit comment generated here */
#include "platform.h"
#include "rl78g14fpbdef.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
extern volatile bool      g_csi00_tx_ready_flag;       /* csi00 send end flag */
extern volatile bool      g_uart3_tx_ready_flag;       /* uart3 send end flag */
extern volatile bool      g_uart3_rx_ready_flag;       /* uart3 receive end flag */

#define NOP0() do{ }while (0)
#define NOP1() do{ NOP(); }while (0)
#define NOP2() do{ NOP();NOP(); }while (0)
#define NOP3() do{ NOP();NOP();NOP(); }while (0)
#define NOP4() do{ NOP();NOP();NOP();NOP(); }while (0)
#define NOP5() do{ NOP();NOP();NOP();NOP();NOP(); }while (0)
#define NOP6() do{ NOP5();NOP(); }while (0)
#define NOP7() do{ NOP5();NOP();NOP(); }while (0)
#define NOP8() do{ NOP5();NOP();NOP();NOP(); }while (0)
#define NOP9() do{ NOP5();NOP();NOP();NOP();NOP(); }while (0)

#define NOP00() do{ }while (0)
#define NOP10() do{ NOP5();NOP5(); }while (0)
#define NOP20() do{ NOP10();NOP10(); }while (0)
#define NOP30() do{ NOP10();NOP10();NOP10(); }while (0)
#define NOP40() do{ NOP10();NOP10();NOP10();NOP10(); }while (0)
#define NOP50() do{ NOP10();NOP10();NOP10();NOP10();NOP10(); }while (0)
#define NOP60() do{ NOP50();NOP10(); }while (0)
#define NOP70() do{ NOP50();NOP10();NOP10(); }while (0)
#define NOP80() do{ NOP50();NOP10();NOP10();NOP10(); }while (0)
#define NOP90() do{ NOP50();NOP10();NOP10();NOP10();NOP10(); }while (0)

#define NOP000() do{ }while (0)
#define NOP100() do{ NOP50();NOP50(); }while (0)
#define NOP200() do{ NOP100();NOP100(); }while (0)
#define NOP300() do{ NOP100();NOP100();NOP100(); }while (0)
#define NOP400() do{ NOP100();NOP100();NOP100();NOP100(); }while (0)
#define NOP500() do{ NOP100();NOP100();NOP100();NOP100();NOP100(); }while (0)
#define NOP600() do{ NOP500();NOP100(); }while (0)
#define NOP700() do{ NOP500();NOP100();NOP100(); }while (0)
#define NOP800() do{ NOP500();NOP100();NOP100();NOP100(); }while (0)
#define NOP900() do{ NOP500();NOP100();NOP100();NOP100();NOP100(); }while (0)

#pragma noinline END
void END(void)
{
    NOP();
}
/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    {
        uint8_t tx[5];
        EI();
        R_CSI00_Start();
        tx[0] = 0;
        tx[1] = 1;
        tx[2] = 2;
        tx[3] = 3;
        tx[4] = 4;
        R_CSI00_Send(tx, 5);

#if 0 /* Renesas RL78 Simulator */
#define SIM if(1)
#define _x_
#define FPB else if(0)
#elif 1 /* RL78/G14 Fast Prototyping Board */
#define SIM if(0)
#define _x_
#define FPB else if(1)
#endif

        /* Note that total clocks of below line are clocks of NOPs + clocks in ISR. */
        SIM{ NOP300();NOP00();NOP5(); } _x_ FPB{ NOP300();NOP10();NOP5(); }
#if 0
        /* LED0 == ON,  LED1 == ON     --> OK */
        /* nothing */
#elif 0
        /* LED0 == ON, LED1 == ON     --> OK */
        DI();
        P1 = 1;
        SIM{ NOP80();NOP9(); } _x_ FPB{ NOP80();NOP6(); }
        P1 = 0;
        EI();
#elif 1
        /* LED0 == OFF, LED1 == ON     --> OK */
        DI();
        P1 = 1;
        SIM{ NOP90();NOP0(); } _x_ FPB{ NOP80();NOP7(); }
        P1 = 0;
        EI();
#elif 0
        /* LED0 == ON, LED1 == ON     --> OK */
        NOP1();
        DI();
        P1 = 1;
        SIM{ NOP90();NOP0(); } _x_ FPB{ NOP80();NOP7(); }
        P1 = 0;
        EI();
#endif
        NOP();

        while (false == g_csi00_tx_ready_flag)
        {
            NOP();
        }
    }
    END();

    while (1U)
    {
        NOP();
    }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
